package net.mcreator.advanced.procedures;

import net.minecraftforge.fml.common.Mod;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.eventbus.api.Event;
import net.minecraftforge.event.entity.player.PlayerInteractEvent;

import net.minecraft.world.phys.Vec3;
import net.minecraft.world.phys.AABB;
import net.minecraft.world.level.LevelAccessor;
import net.minecraft.world.item.alchemy.Potions;
import net.minecraft.world.item.alchemy.PotionUtils;
import net.minecraft.world.item.Items;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.entity.monster.Witch;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.effect.MobEffects;
import net.minecraft.server.level.ServerPlayer;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.advancements.AdvancementProgress;
import net.minecraft.advancements.Advancement;

import net.mcreator.advanced.AdvancedMod;

import javax.annotation.Nullable;

import java.util.List;
import java.util.Comparator;

@Mod.EventBusSubscriber
public class PoisonWitchProcedure {
	@SubscribeEvent
	public static void onRightClickItem(PlayerInteractEvent.RightClickItem event) {
		if (event.getHand() != event.getEntity().getUsedItemHand())
			return;
		execute(event, event.getLevel(), event.getPos().getX(), event.getPos().getY(), event.getPos().getZ(), event.getEntity());
	}

	public static void execute(LevelAccessor world, double x, double y, double z, Entity entity) {
		execute(null, world, x, y, z, entity);
	}

	private static void execute(@Nullable Event event, LevelAccessor world, double x, double y, double z, Entity entity) {
		if (entity == null)
			return;
		ItemStack item = ItemStack.EMPTY;
		double repeats = 0;
		item = (entity instanceof LivingEntity _livEnt ? _livEnt.getMainHandItem() : ItemStack.EMPTY);
		if (item.getItem() == (PotionUtils.setPotion(Items.SPLASH_POTION.getDefaultInstance(), Potions.POISON)).getItem() || item.getItem() == (PotionUtils.setPotion(Items.LINGERING_POTION.getDefaultInstance(), Potions.POISON)).getItem()
				|| item.getItem() == (PotionUtils.setPotion(Items.SPLASH_POTION.getDefaultInstance(), Potions.LONG_POISON)).getItem()
				|| item.getItem() == (PotionUtils.setPotion(Items.LINGERING_POTION.getDefaultInstance(), Potions.LONG_POISON)).getItem()
				|| item.getItem() == (PotionUtils.setPotion(Items.SPLASH_POTION.getDefaultInstance(), Potions.STRONG_POISON)).getItem()
				|| item.getItem() == (PotionUtils.setPotion(Items.LINGERING_POTION.getDefaultInstance(), Potions.STRONG_POISON)).getItem()) {
			repeats = 0;
			while (20 > repeats) {
				AdvancedMod.queueServerWork((int) (repeats * 10), () -> {
					{
						final Vec3 _center = new Vec3(x, y, z);
						List<Entity> _entfound = world.getEntitiesOfClass(Entity.class, new AABB(_center, _center).inflate(20 / 2d), e -> true).stream().sorted(Comparator.comparingDouble(_entcnd -> _entcnd.distanceToSqr(_center))).toList();
						for (Entity entityiterator : _entfound) {
							if (entityiterator instanceof Witch && entityiterator instanceof LivingEntity _livEnt14 && _livEnt14.hasEffect(MobEffects.POISON)) {
								if (entity instanceof ServerPlayer _player) {
									Advancement _adv = _player.server.getAdvancements().getAdvancement(new ResourceLocation("advanced:taste_of_your_own_medicine"));
									AdvancementProgress _ap = _player.getAdvancements().getOrStartProgress(_adv);
									if (!_ap.isDone()) {
										for (String criteria : _ap.getRemainingCriteria())
											_player.getAdvancements().award(_adv, criteria);
									}
								}
							}
						}
					}
				});
				repeats = repeats + 1;
			}
		}
	}
}
